#ifndef NOTIFYPOPUP_H
#define NOTIFYPOPUP_H

#include <QWidget>
#include <QHBoxLayout>
#include <QLabel>
#include <QToolButton>

#include "notifymessage.h"
#include "../panel/ndepanel.h"
#include "../panel/indepanelplugin.h"

class NotifyPopup : public QWidget
{
    Q_OBJECT

public:
    explicit NotifyPopup(INdePanelPlugin * plugin, QWidget *parent = nullptr);
    ~NotifyPopup();

    void setValues(NotifyMessage nm);

    void realign();

Q_SIGNALS:
    void triggered();
    void actionTriggered(uint id, const QString &actionKey);

protected:
    bool event(QEvent *event) override;

private Q_SLOTS:
    void slotActionBtnClicked();
    void slotClose();

private:
    INdePanelPlugin * mPlugin;

    INdePanel::Position mCurPanelPos; //位置
    bool mCompositorOpen; //特效开关
    NotifyMessage m_notifyMsg;
    QWidget * mBackground; //实际背景

    //界面元素
    QHBoxLayout * m_layout;
    QLabel * m_labelIcon;
    QVBoxLayout * m_layout_icon;
    QLabel * m_labelApplication;
    QLabel * m_labelSummary;
    QLabel * m_labelBody;
    QVBoxLayout * m_layout_text;
    QToolButton * m_btn_close;
    QVBoxLayout * m_layout_btn;

    QFrame * m_frame_actions;
    QList<QToolButton*> m_btn_actions;
    QGridLayout * m_layout_actions;
};

#endif // NOTIFYPOPUP_H
